<?php

if (isset($_POST["submit"])) {

/* Remember to change the permissions on the XML file
   to allow write access by everyone

   N.B. <xmp> tag now deprecated, but a useful way of displaying the XML code on the page
*/

   $file = "books.xml";
   $fp = fopen($file, "rb") or die("Error - cannot open XML file");
   $str = fread($fp, filesize($file));

   $xml = new DOMDocument();
   $xml->formatOutput = true;
   $xml->preserveWhiteSpace = false;
   $xml->loadXML($str) or die("Error - cannot load XML data");

   // get document element
   $root= $xml->documentElement;
   $nextIDNode=$root->childNodes->item(0);
   $books= $root->childNodes->item(1);

   // output original XML fle
   echo "<xmp>OLD:\n". $xml->saveXML() ."</xmp>";

   // find first book element
   $firstBook=$books->childNodes->item(0);

   // get values for new book element
   $newID=(int)$root->childNodes->item(0)->nodeValue;
   $newTitle=$_POST["title"];
   $newAuthor=$_POST["author"];

   // create the title element
   $titleNode=$xml->createElement("title");
   $titleTextNode=$xml->createTextNode("$newTitle");
   $titleNode->appendChild($titleTextNode);

   // create the author element
   $authorNode=$xml->createElement("author");
   $authorTextNode=$xml->createTextNode("$newAuthor");
   $authorNode->appendChild($authorTextNode);

   // create the new book
   $newBookNode=$xml->createElement("book");
   $newBookNode->setAttribute("id",$newID);
   $newBookNode->appendChild($titleNode);
   $newBookNode->appendChild($authorNode);

   // add new book to the data set
   $books->insertBefore($newBookNode,$firstBook);

   // output and save new XML file
   echo "<xmp>NEW:\n". $xml->saveXML() ."</xmp>";
   $xml->save("books.xml");

} else {
?>
<html>
<head>
<title>XML Add New Element</title>
</head>

<body>
<h1>Add new book</h1>
<form method="post" action="addBook.php">
  Name: <input type="text" name="author"><br>
  Title: <input type="text" name="title"><br>
  <input type="submit" name="submit" value="Add">
</form>
</body>

</html>
<?php
}
?>
